## net.sf.saxon.om
Interface ExternalObjectModel

All Known Implementing Classes:
  DOM4JObjectModel, DOMEnvelope, DOMObjectModel, JDOMObjectModel, XOMObjectModel

    public interface ExternalObjectModel

This interface must be implemented by any third-party object model that can be wrapped with a wrapper that implements the Saxon Object Model (the NodeInfo interface).

This interface is designed to enable advanced applications to implement and register new object model implementations that Saxon can then use without change. Although it is intended for external use, it cannot at this stage be considered part of the stable Saxon Public API. In particular, it is likely that the interface will grow by the addition of new methods.

Method Summary
`Receiver` `getDocumentBuilder(javax.xml.transform.Result result)` Test whether this object model recognizes a particular kind of JAXP Result object, and if it does, return a Receiver that builds an instance of this data model from a sequence of events.
`java.lang.String` `getIdentifyingURI()` Get the URI of the external object model as used in the JAXP factory interfaces for obtaining an XPath implementation
`JPConverter` `getJPConverter(java.lang.Class targetClass)` Get a converter from XPath values to values in the external object model
`PJConverter` `getNodeListCreator(java.lang.Object node)` Get a converter that converts a sequence of XPath nodes to this model's representation of a node list.
`PJConverter` `getPJConverter(java.lang.Class targetClass)` Get a converter from XPath values to values in the external object model
`boolean` `sendSource(javax.xml.transform.Source source, Receiver receiver, PipelineConfiguration pipe)` Test whether this object model recognizes a particular kind of JAXP Source object, and if it does, send the contents of the document to a supplied Receiver, and return true.
`NodeInfo` `unravel(javax.xml.transform.Source source, Configuration config)` Wrap or unwrap a node using this object model to return the corresponding Saxon node.

Method Detail

### getIdentifyingURI

    java.lang.String getIdentifyingURI()

  Get the URI of the external object model as used in the JAXP factory interfaces for obtaining an XPath implementation

### getPJConverter

    PJConverter getPJConverter(java.lang.Class targetClass)

  Get a converter from XPath values to values in the external object model

  Parameters:
    `targetClass` - the required class of the result of the conversion. If this class represents a node or list of nodes in the external object model, the method should return a converter that takes a native node or sequence of nodes as input and returns a node or sequence of nodes in the external object model representation. Otherwise, it should return null.
  Returns:
    a converter, if the targetClass is recognized as belonging to this object model; otherwise null

### getJPConverter

    JPConverter getJPConverter(java.lang.Class targetClass)

  Get a converter from XPath values to values in the external object model

  Parameters:
    `targetClass` - the required class of the result of the conversion. If this class represents a node or list of nodes in the external object model, the method should return a converter that takes an object of this class as input and returns a node or sequence of nodes in the native Saxon representation. Otherwise, it should return null.
  Returns:
    a converter, if the targetClass is recognized as belonging to this object model; otherwise null

### getNodeListCreator

    PJConverter getNodeListCreator(java.lang.Object node)

  Get a converter that converts a sequence of XPath nodes to this model's representation of a node list.

  Parameters:
    `node` - an example of the kind of node used in this model
  Returns:
    if the model does not recognize this node as one of its own, return null. Otherwise return a PJConverter that takes a list of XPath nodes (represented as NodeInfo objects) and returns a collection of nodes in this object model

### getDocumentBuilder

    Receiver getDocumentBuilder(javax.xml.transform.Result result)
                                throws XPathException

  Test whether this object model recognizes a particular kind of JAXP Result object, and if it does, return a Receiver that builds an instance of this data model from a sequence of events. If the Result is not recognised, return null.

  Parameters:
    `result` - a JAXP result object
  Returns:
    a Receiver that writes to that result, if available; or null otherwise
  Throws:
    `XPathException`

### sendSource

    boolean sendSource(javax.xml.transform.Source source,
                       Receiver receiver,
                       PipelineConfiguration pipe)
                       throws XPathException

  Test whether this object model recognizes a particular kind of JAXP Source object, and if it does, send the contents of the document to a supplied Receiver, and return true. Otherwise, return false.

  Parameters:
    `source` - a JAXP Source object
    `receiver` - the Receiver that is to receive the data from the Source
    `pipe` - configuration information
  Returns:
    true if the data from the Source has been sent to the Receiver, false otherwise
  Throws:
    `XPathException`

### unravel

    NodeInfo unravel(javax.xml.transform.Source source,
                     Configuration config)

  Wrap or unwrap a node using this object model to return the corresponding Saxon node. If the supplied source does not belong to this object model, return null

  Parameters:
    `source` - a JAXP Source object
    `config` - the Saxon configuration
  Returns:
    a NodeInfo corresponding to the Source, if this can be constructed; otherwise null

Copyright (c) Saxonica Limited. All rights reserved.